private import std.string;
private import hell2;
private import sysinfo;
private import natsuki2;
private import enemy;
private import lua;
private import luaexecutor;

private:
extern (C)
{
	int __ENEMY_SetAppearTimer(lua_State L)
	{
		char[] funcname = "SET_APPEAR_TIMER";
		auto arg1 = Lua.readInt(L, funcname, 1);
		Enemy.setAppearTimer(arg1);
		
		return 1;
	}
	// 敵の生成(出現演出あり)
	int __ENEMY_AddEx(lua_State L)
	{
		char[] funcname = "ENEMY";
		int n = lua_gettop(L);
		auto arg1 = Lua.readInt(L, funcname, 1);
		auto arg2 = Lua.readInt(L, funcname, 2);
		auto arg3 = Lua.readInt(L, funcname, 3);
		auto arg4 = 0;
		if(n == 4) arg4 = Lua.readInt(L, funcname, 4);
		Enemy e = Enemy.addEx(arg1, arg2, arg3);
		if(arg4 > 0)
		{
			e.setAttribute(arg4);
		}
		return 1;
	}
	// 敵の生成(FMFから読み込み)
	int __ENEMY_LoadFMF(lua_State L)
	{
		char[] funcname = "FMF";
		auto arg1 = Lua.readString(L, funcname, 1);
		// パスをくっつけて読み込む
		Enemy.loadFMF(format("%s/%s", LevelManager.getLevelDirectory(), arg1));
		
		return 1;
	}
	// スクリプト実行停止
	int __WAIT(lua_State L)
	{
		char[] funcname = "WAIT";
		auto arg1 = Lua.readInt(L, funcname, 1);
		LevelManager.setWait(arg1);
		
		return 1;
	}
	// スクリプト実行停止(早回し)
	int __WAIT2(lua_State L)
	{
		char[] funcname = "WAIT2";
		auto arg1 = Lua.readInt(L, funcname, 1);
		LevelManager.setWait(arg1, true);
		return 1;
	}
	// BGMの再生
	int __BGM(lua_State L)
	{
		char[] funcname = "BGM";
		auto arg1 = Lua.readString(L, funcname, 1);
		Hell_playBgm(format("resource/sound/%s", arg1));
		return 1;
	}
	// BGMの再生(フェード)
	int __BGM2(lua_State L)
	{
		char[] funcname = "BGM2";
		auto arg1 = Lua.readString(L, funcname, 1);
		Hell_stopBgm(1000);
		Hell_wait(1000);
		Hell_playBgm(format("resource/sound/%s", arg1));
		return 1;
	}
	// BGMの停止
	int __BGMOFF(lua_State L)
	{
		char[] funcname = "BGMOFF";
		int n = lua_gettop(L);
		auto arg1 = 0;
		if(n == 1) arg1 = Lua.readInt(L, funcname, 1);
		Hell_stopBgm(arg1);
		return 1;
	}
	// 制限時間の設定
	int __LIMIT(lua_State L)
	{
		char[] funcname = "LIMIT";
		auto arg1 = Lua.readInt(L, funcname, 1);
		SceneMain.setLimitTime(arg1);
		return 1;
	}
	// ゲーム終了待ちの設定
	int __END(lua_State L)
	{
		char[] funcname = "END";
		SceneMain.beginEndAtAllDestroy();
		return 1;
	}
	// ダメージフレームの減少時間の設定
	int __DMG1_VAL(lua_State L)
	{
		char[] funcname = "DMG1_VAL";
		auto arg1 = Lua.readInt(L, funcname, 1);
		SceneMain.setDmg1Val(arg1);
		return 1;
	}
	// ダメージ中の減少時間
	int __DMG2_VAL(lua_State L)
	{
		char[] funcname = "DMG2_VAL";
		auto arg1 = Lua.readInt(L, funcname, 1);
		SceneMain.setDmg2Val(arg1);
		return 1;
	}
	// ダメージ中の減少時間の間隔
	int __DMG2_TIME(lua_State L)
	{
		char[] funcname = "DMG2_TIME";
		auto arg1 = Lua.readInt(L, funcname, 1);
		SceneMain.setDmg2Interval(arg1);
		return 1;
	}
	// ランクの設定
	int __RANK(lua_State L)
	{
		char[] funcname = "RANK";
		auto arg1 = Lua.readInt(L, funcname, 1);
		Enemy.Rank = arg1;
		return 1;
	}
	// 敵HPの設定
	int __ENEMY_HP(lua_State L)
	{
		char[] funcname = "ENEMY_HP";
		auto arg1 = Lua.readInt(L, funcname, 1);
		auto arg2 = Lua.readInt(L, funcname, 2);
		Enemy.setHp(arg1, arg2);
		return 1;
	}
	// お助けバナナ
	int __BANANA(lua_State L)
	{
		char[] funcname = "BANANA";
		auto arg1 = Lua.readInt(L, funcname, 1);
		SceneMain.setBanana(arg1);
		return 1;
	}
	// 背景エフェクト
	int __BACK(lua_State L)
	{
		char[] funcname = "BACK";
		auto arg1 = Lua.readInt(L, funcname, 1);
		auto arg2 = Lua.readInt(L, funcname, 2);
		SceneMain.setBack(arg1, arg2);
		return 1;
	}
	// 打ち返しウェイト
	int __TIMER_REFLECT(lua_State L)
	{
		char[] funcname = "TIMER_REFLECT";
		auto arg1 = Lua.readInt(L, funcname, 1);
		GH.MAIN_REFLECT_TIMER = arg1;
		return 1;
	}
	// 攻撃ウェイト
	int __TIMER_ATTACK(lua_State L)
	{
		char[] funcname = "TIMER_ATTACK";
		auto arg1 = Lua.readInt(L, funcname, 1);
		GH.MAIN_ATTACK_TIMER = arg1;
		return 1;
	}
	// 金魚鉢装着
	int __KINGYO(lua_State L)
	{
		char[] funcname = "KINGYO";
		Player.setKingyo();
		return 1;
	}
}


public:
/**
 * レベル管理クラス
 */
class LevelManager : Lua
{
private:
	static int    _tWait;          // スクリプト実行待ちタイマ
	static bool   _bQuick;         // 早回しフラグ
	static char[] _levelDirectory; // レベルディレクトリ
	Lua           _lua;            // Luaオブジェクト
public:
	this()
	{
		_lua = new Lua();
	}
	~this() { _lua.close(); }
	static void setWait(int t, bool bQuick=false)
	{
		_tWait  = t;
		_bQuick = bQuick;
	}
	static char[] getLevelDirectory() { return _levelDirectory; }
	void load(char[] levelDirectory)
	{
		// レベルディレクトリ設定
		_levelDirectory = levelDirectory.dup;
		
		_tWait = 0;
		_lua.close();
		// ライブラリの指定
		_lua.setUseLib(LIB_MATH);
		// Luaロード
		_lua.load(format("%s/run.lua", _levelDirectory));
		
		// 関数登録
		_lua.regist("APPEAR",        &__ENEMY_SetAppearTimer);
		_lua.regist("ENEMY",         &__ENEMY_AddEx);
		_lua.regist("FMF",           &__ENEMY_LoadFMF);
		_lua.regist("WAIT",          &__WAIT);
		_lua.regist("WAIT2",         &__WAIT2);
		_lua.regist("BGM",           &__BGM);
		_lua.regist("BGM2",          &__BGM2);
		_lua.regist("BGMOFF",        &__BGMOFF);
		_lua.regist("LIMIT",         &__LIMIT);
		_lua.regist("END",           &__END);
		_lua.regist("DMG1_VAL",      &__DMG1_VAL);
		_lua.regist("DMG2_VAL",      &__DMG2_VAL);
		_lua.regist("DMG2_TIME",     &__DMG2_TIME);
		_lua.regist("RANK",          &__RANK);
		_lua.regist("ENEMY_HP",      &__ENEMY_HP);
		_lua.regist("BANANA",        &__BANANA);
		_lua.regist("BACK",          &__BACK);
		_lua.regist("TIMER_REFLECT", &__TIMER_REFLECT);
		_lua.regist("TIMER_ATTACK",  &__TIMER_ATTACK);
		_lua.regist("KINGYO",        &__KINGYO);
	}
	void update()
	{
		if(_tWait > 0)
		{
			_tWait--;
			if(!_bQuick) return; // 早回しなし
			if(Enemy.parent.count() > 1) return; // まだ敵がいる
			_tWait = 0;
		}
		_lua.resume();
	}
}

