private import std.string;
private import configparser;

/**
 * システム定数
 */
class GH
{
public
	// システム
	static int     WIDTH;
	static int     HEIGHT;
	static bool    DEBUG;
	static char[]  SAVE_DATA;
	// プレイヤー  
	static int     PLAYER_SIZE;         // サイズ
	static float   PLAYER_DAMAGE_SPEED; // ダメージ時に吹き飛ばされる移動量
	static float   PLAYER_DECAY_SPEED;  // 移動の減衰量
	static int     PLAYER_DAMAGE_TIMER; // ダメージタイマ
	static int     PLAYER_COUNT_TIMER;  // 体当たりでの打ち返し演出タイマ
	// 照準
	static int     AIM_SIZE;            // 半径
	static bool    AIM_REFLECT;         // 弾消しで打ち返し
	// ショット
	static int     SHOT_DECAY;          // ショットの減衰(0～100)
	static int     SHOT_RELOAD_TIMER;   // 再開時間(2sec)
	static float   SHOT_BLOW_SPEED;     // 衝突時のスピード
	static int     SHOT_SIZE;           // 半径
	static bool    SHOT_DAMAGE_ENEMY;   // ダメージ中の敵にあたるかどうか
	static int     SHOT_SEARCH_LENGTH;  // 軌道予測の長さ

	// 打ち返し
	static int     REFLECT_SIZE;        // サイズ
	static float   REFLECT_SPEED;       // 速さ
	static float   REFLECT_BLOW_SPEED;  // 衝突時のスピード
	static int     REFLECT_DAMAGE;      // ダメージ量
	static int     REFLECT_BULLET_CNT;  // 打ち返す弾の数
	static bool    REFLECT_BOSS_GUIDE;  // ボスへの誘導
	static float   REFLECT_ROT_INIT;    // 旋回速度(初期値)
	static float   REFLECT_ROT_INC;     // 旋回速度(増加率)
	static float   REFLECT_ROT_MAX;     // 旋回速度(最大)
	static int     REFLECT_MARGIN;      // 消去判定(画面外)のマージン
	// 敵弾
	static int     BULLET_SIZE;         // サイズ
	// 敵
	static float   ENEMY_DAMAGE_SIZE;   // 敵ダメージ時のサイズの倍率
	static float   ENEMY_BLOW_SPEED;    // 敵同士の衝突のスピード
	static int     ENEMY_KIND_COUNT;    // 敵の種類
	static int     ENEMY_BASE_DAMAGE;   // ベースとなるダメージ量
	static int[]   ENEMY_SIZE;          // サイズ
	static int[]   ENEMY_SCORE;         // スコア
	static float[] ENEMY_DECAY;         // 減衰量
	static bool    ENEMY_HP_STRING;     // HPを文字で表示
	// アイテム
	static int     ITEM_BANANA_POWER;   // ばななの時間エクステンド値
	static int     ITEM_BANANA2_POWER;  // ばなな２の時間エクステンド値
	static int     ITEM_SORB_SIZE;      // 吸着サイズ
	static float   ITEM_SORB_SPEED;     // 吸着スピード
	// メイン
	static int     MAIN_RATIO_MAX;      // 連鎖倍率の最大
	static int     MAIN_REFLECT_TIMER;  // 打ち返しヒット時のウェイト
	static int     MAIN_ATTACK_TIMER;   // 攻撃ヒット時のウェイト
	static int     MAIN_DAMAGE_TIMER;   // 自機ダメージ時のウェイト
	static int     MAIN_SUICIDE_TIMER;  // ボス自爆タイマー
	// ベストタイム
	static int     BEST_EASY;
	static int     BEST_NORMAL;
	static int     BEST_HARD;
	static int     BEST_HELL;
	
	static void load()
	{
		scope cfg = new ConfigParser();
		cfg.load("resource/level/game.ini");
		WIDTH               = cfg.getint("WIDTH");
		HEIGHT              = cfg.getint("HEIGHT");
		DEBUG               = cfg.getboolean("DEBUG");
		SAVE_DATA           = cfg.get("SAVE_DATA");
		PLAYER_SIZE         = cfg.getint("PLAYER_SIZE");
		PLAYER_DAMAGE_SPEED = cfg.getfloat("PLAYER_DAMAGE_SPEED");
		PLAYER_DECAY_SPEED  = cfg.getfloat("PLAYER_DECAY_SPEED");
		PLAYER_DAMAGE_TIMER = cfg.getint("PLAYER_DAMAGE_TIMER");
		PLAYER_COUNT_TIMER  = cfg.getint("PLAYER_COUNT_TIMER");
		AIM_SIZE            = cfg.getint("AIM_SIZE");
		AIM_REFLECT         = cfg.getboolean("AIM_REFLECT");
		SHOT_DECAY          = cfg.getint("SHOT_DECAY");
		SHOT_RELOAD_TIMER   = cfg.getint("SHOT_RELOAD_TIMER");
		SHOT_BLOW_SPEED     = cfg.getfloat("SHOT_BLOW_SPEED");
		SHOT_SIZE           = cfg.getint("SHOT_SIZE");
		SHOT_DAMAGE_ENEMY   = cfg.getboolean("SHOT_DAMAGE_ENEMY");
		SHOT_SEARCH_LENGTH  = cfg.getint("SHOT_SEARCH_LENGTH");
		REFLECT_SIZE        = cfg.getint("REFLECT_SIZE");
		REFLECT_SPEED       = cfg.getfloat("REFLECT_SPEED");
		REFLECT_BLOW_SPEED  = cfg.getfloat("REFLECT_BLOW_SPEED");
		REFLECT_DAMAGE      = cfg.getint("REFLECT_DAMAGE");
		REFLECT_BULLET_CNT  = cfg.getint("REFLECT_BULLET_CNT");
		REFLECT_BOSS_GUIDE  = cfg.getboolean("REFLECT_BOSS_GUIDE");
		REFLECT_ROT_INIT    = cfg.getfloat("REFLECT_ROT_INIT");
		REFLECT_ROT_INC     = cfg.getfloat("REFLECT_ROT_INC");
		REFLECT_ROT_MAX     = cfg.getfloat("REFLECT_ROT_MAX");
		REFLECT_MARGIN      = cfg.getint("REFLECT_MARGIN");
		ITEM_BANANA_POWER   = cfg.getint("ITEM_BANANA_POWER");
		ITEM_BANANA2_POWER  = cfg.getint("ITEM_BANANA2_POWER");
		ITEM_SORB_SIZE      = cfg.getint("ITEM_SORB_SIZE");
		ITEM_SORB_SPEED     = cfg.getfloat("ITEM_SORB_SPEED");
		BULLET_SIZE         = cfg.getint("BULLET_SIZE");
		MAIN_RATIO_MAX      = cfg.getint("MAIN_RATIO_MAX");
		MAIN_REFLECT_TIMER  = cfg.getint("MAIN_REFLECT_TIMER");
		MAIN_ATTACK_TIMER   = cfg.getint("MAIN_ATTACK_TIMER");
		MAIN_DAMAGE_TIMER   = cfg.getint("MAIN_DAMAGE_TIMER");
		MAIN_SUICIDE_TIMER  = cfg.getint("MAIN_SUICIDE_TIMER");
		BEST_EASY           = cfg.getint("BEST_EASY");
		BEST_NORMAL         = cfg.getint("BEST_NORMAL");
		BEST_HARD           = cfg.getint("BEST_HARD");
		BEST_HELL           = cfg.getint("BEST_HELL");
		ENEMY_DAMAGE_SIZE   = cfg.getfloat("ENEMY_DAMAGE_SIZE");
		ENEMY_BLOW_SPEED    = cfg.getfloat("ENEMY_BLOW_SPEED");
		ENEMY_KIND_COUNT    = cfg.getint("ENEMY_KIND_COUNT");
		ENEMY_BASE_DAMAGE   = cfg.getint("ENEMY_BASE_DAMAGE");
		ENEMY_HP_STRING     = cfg.getboolean("ENEMY_HP_STRING");
		ENEMY_SIZE  = new int[ENEMY_KIND_COUNT+1];
		ENEMY_SCORE = new int[ENEMY_KIND_COUNT+1];
		ENEMY_DECAY = new float[ENEMY_KIND_COUNT+1];
		for(int i = 1; i < ENEMY_KIND_COUNT+1; i++)
		{
			ENEMY_SIZE[i]  = cfg.getint(format("ENEMY_%02d_SIZE", i));
			ENEMY_SCORE[i] = cfg.getint(format("ENEMY_%02d_SCORE", i));
			ENEMY_DECAY[i] = cfg.getfloat(format("ENEMY_%02d_DECAY", i));
		}
	}
}
